package com.karensrecipes.midlets;

import com.karensrecipes.midlets.utils.*;
import javax.microedition.lcdui.*;

public class FormSearch extends Form implements CommandListener {
	
	private RecipeBrowser midlet;
	private Command cmBack;
	private Command cmSearch;
	private TextField tfSearch;
	
	
	public FormSearch(RecipeBrowser midlet) {
		
		// call the constructor of the List
		super("Search Recipes:");
		
		// save the top level midlet locally
		this.midlet = midlet;
		
		
		tfSearch = new TextField("Enter keyword(s):", "", 10, TextField.ANY);			
		
		cmBack = new Command("Back", Command.SCREEN, 2);
		cmSearch = new Command("Search", Command.OK, 1);
		addCommand(cmBack);
		addCommand(cmSearch);
		append(tfSearch);
		setCommandListener(this);
		
	}
	
	public void commandAction(Command c, Displayable s) {
		
		if (c == cmSearch) {
			
			// start searching the database...
			Thread st = new Thread(new RecipeSearchThread(midlet, tfSearch.getString()));
			st.start();
			
			// show the content form with a message
			midlet.displayManager.pushDisplayable(new FormContent(midlet, "Searching the recipe database for '" + tfSearch.getString() + "'.  Please wait..."));
			
			
			
			
		} else if (c == cmBack) {
			
			midlet.displayManager.popDisplayable();
		
		}
		
		
	}

}
