package com.karensrecipes.midlets;

import javax.microedition.lcdui.*;
import com.karensrecipes.midlets.utils.*;

public class ListCategory extends List implements CommandListener {
	
	private RecipeBrowser midlet;
	private Command cmBack;
	
	public ListCategory(RecipeBrowser midlet) {
		
		// call the constructor of the List
		super("Choose Category:", List.IMPLICIT);
		
		// save the top level midlet locally
		this.midlet = midlet;
		
		
		
		// add each category to the List
		for (int i=0; i<midlet.categories.size(); i++) {
			append(((Category)midlet.categories.elementAt(i)).getLabel(), null);
		}
		
		cmBack = new Command("Back", Command.SCREEN, 1);
		
		addCommand(cmBack);
		setCommandListener(this);
		
		
		
	}
	
	
	
	
	
	public void commandAction(Command c, Displayable s) {
		
		if (c == List.SELECT_COMMAND) {
			
			Category cat = (Category)midlet.categories.elementAt(getSelectedIndex());
			
			//start up a Thread to retrieve the recipes, which will then 
			// refresh the screen when it's done....
			Thread st = new Thread(new RecipeFetcherThread(midlet, cat));
			st.start();
			
			// show the content form with a message
			midlet.displayManager.pushDisplayable(new FormContent(midlet, "Downloading recipes.... please wait..."));
			
			
			
		} else if (c == cmBack) {
			
			midlet.displayManager.popDisplayable();
			
		}			
	}

}
