package com.karensrecipes.midlets;

import com.karensrecipes.midlets.utils.*;
import java.util.Vector;
import javax.microedition.lcdui.*;

public class ListRecipes extends List implements CommandListener {
	
	private Vector recipes;
	private RecipeBrowser midlet;
	private Command cmBack;
	
	// constructor given a Category (which contains recipes)
	public ListRecipes(Category category, RecipeBrowser midlet) {
		super("Choose Recipe:", List.IMPLICIT);
		this.midlet = midlet;
		this.recipes = category.getRecipes();
		init();
		
	}
	
	// constructor given a Vector of recipes
	public ListRecipes(Vector recipes, RecipeBrowser midlet) {
		super("Choose Recipe:", List.IMPLICIT);
		this.midlet = midlet;
		this.recipes = recipes;
		init();
	}
	
	
	private void init() {
		// add each category to the List
		for (int i=0; i<recipes.size(); i++) {
			System.out.println(((Recipe)recipes.elementAt(i)).getLabel());
			append(((Recipe)recipes.elementAt(i)).getLabel(), null);
		}
		
		cmBack = new Command("Back", Command.SCREEN, 1);
		addCommand(cmBack);
		setCommandListener(this);
	}
	
	
	
	public void commandAction(Command c, Displayable s) {
		
		if (c == List.SELECT_COMMAND) {
			Recipe r = (Recipe)recipes.elementAt(getSelectedIndex());
			
			//start up a Thread to retrieve the recipes
			Thread st = new Thread(new RecipeDetailFetcherThread(midlet, r));
			st.start();
			
			midlet.displayManager.pushDisplayable(new FormContent(midlet, "Downloading recipe.... please wait..."));
			
			
			
		} else if (c == cmBack) {
			
			// pop back 2 screens to the category listing
			midlet.displayManager.popDisplayable();
			midlet.displayManager.popDisplayable();
		}			
	}

}
