package com.karensrecipes.midlets.utils;

import java.io.*;
import javax.microedition.io.*;
import org.kxml.*;
import org.kxml.parser.*;
import com.karensrecipes.midlets.*;

public class RecipeDetailFetcherThread implements Runnable {
	
	private RecipeBrowser midlet;
	private Recipe recipe;
	
	
	public RecipeDetailFetcherThread(RecipeBrowser midlet, Recipe recipe) {
		
		this.midlet = midlet;
		this.recipe = recipe;
		
	}
	
	
	public void run() {
		
		// establish internet connection
		InputStream is = null;
		OutputStream os = null;
		HttpConnection conn = null;
		String query = "recipeid=" + recipe.getId();
		String requestMethod = HttpConnection.GET;
		String name = RecipeBrowser.QUERY_URL;
		
		
		try {
			conn = (HttpConnection)Connector.open(name + query, Connector.READ_WRITE);

			conn.setRequestMethod(requestMethod);
			conn.setRequestProperty("Connection", "Close");
		
			// Read the response from the server
			is = conn.openInputStream();
			int code = conn.getResponseCode();
			
			String type = conn.getType();
			if (code == HttpConnection.HTTP_OK) {
				
				try {
					
					Reader reader = new InputStreamReader(is);
					XmlParser parser = new XmlParser(reader);
					ParseEvent pe = null;
	
					// skip the doctype
					parser.skip();
					
					// look for <recipe>
					parser.read(Xml.START_TAG, null, "recipe");
					
					boolean trucking = true;
					while (trucking) {
					
						pe = parser.read();
						
						if (pe.getType() == Xml.START_TAG && pe.getName().equals("ingredients")) {
							pe = parser.read();
							recipe.setIngredients("Ingredients: " + pe.getText());	
						
						} else if (pe.getType() == Xml.START_TAG && pe.getName().equals("directions")) {
							pe = parser.read();
							recipe.setDirections("Directions: " + pe.getText());
							
							// stop the loop
							trucking = false;
						}
					}
					
				} catch (Exception e) {
					System.out.println(e.toString()); 		
					midlet.displayManager.pushDisplayable(new FormError(midlet, e.toString()));
					
				} 
				  
			} else {
				System.out.println("HttpConnection != HTTP_OK");
				midlet.displayManager.pushDisplayable(new FormError(midlet, "HttpConnection = " + code));
			}
			
		} catch (IOException io ) {
			System.out.println(io.toString());
			midlet.displayManager.pushDisplayable(new FormError(midlet, io.toString()));
		}
		
		//	display the recipe
		midlet.displayManager.pushDisplayable(new FormRecipe(midlet, recipe));
			
	}
	
		
	
	

}
