package com.karensrecipes.midlets.utils;

import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import org.kxml.*;
import org.kxml.parser.*;
import com.karensrecipes.midlets.*;

public class RecipeFetcherThread implements Runnable {
	
	private Category category;
	private RecipeBrowser midlet;
	
	public RecipeFetcherThread(RecipeBrowser midlet, Category category) {
		
		this.midlet = midlet;
		this.category = category;
	}
	
	
	public void run() {
		
		// establish internet connection
		InputStream is = null;
		OutputStream os = null;
		HttpConnection conn = null;
		String query = "categoryid=" + category.getCategoryid();
		String requestMethod = HttpConnection.GET;
		String name = RecipeBrowser.QUERY_URL;
		
		
		try {
			conn = (HttpConnection)Connector.open(name + query, Connector.READ_WRITE);

			conn.setRequestMethod(requestMethod);
			// conn.setRequestProperty("Connection", "Close");
		
			// Read the response from the server
			is = conn.openInputStream();
			int code = conn.getResponseCode();
			
			String type = conn.getType();
			if (code == HttpConnection.HTTP_OK) {
				
				Vector v = new Vector();
				
				try {
					Reader reader = new InputStreamReader(is);
					XmlParser parser = new XmlParser(reader);
					ParseEvent pe = null;
	
					// skip the doctype
					parser.skip();
					parser.read(Xml.START_TAG, null, "recipes");
					
					// skip ?
					pe = parser.read();
					System.out.println(pe.getType());
					
					boolean trucking = true;
					
					Integer recipeid;
					while (trucking) {
						
						pe = parser.read();
						
						// if we find <recipe>
					  	if (pe.getType() == Xml.START_TAG) {
					  		
					  		// get the recipe id from the attribute
							Attribute a = pe.getAttribute("id");
							recipeid = Integer.valueOf(a.getValue());
							
							// fire read() again, get the text of <recipe>text</recipe>
							pe = parser.read();
							
							// construct a recipe object
							Recipe r = new Recipe(recipeid, pe.getText());
							
							// add it to  
							v.addElement(r);
							
						}
				  		
				  		
				  		// if we get to the end, then quit
				  		if (pe.getType() == Xml.END_TAG && pe.getName().equals("recipes")) {
				  			trucking = false;
				  		}
				  		
						
				  		
					}
					
				} catch (Exception e) {
					System.out.println(e.toString()); 		
					midlet.displayManager.pushDisplayable(new FormError(midlet, e.toString()));
				} 
				  
					
				
				//	display the recipe list
				midlet.displayManager.pushDisplayable(new ListRecipes(v, midlet));
					
				
			} else {
				// show the error form
				midlet.displayManager.pushDisplayable(new FormError(midlet, "code = " + code + ", type = " + type));
			}
			
		} catch (IOException io ) {
			System.out.println(io.toString());
			
			//show the error form
			midlet.displayManager.pushDisplayable(new FormError(midlet, io.toString()));
		}
		
	}
	
		
	
	

}
