package com.karensrecipes.midlets;

import javax.microedition.lcdui.*;
import java.util.*;

public class DisplayManager extends Stack {
	

	private Display display; // reference to Display object
	private Displayable mainDisplayable; // Main displayable for MIDlet
	private Alert alStackError; // Alert for error conditions
	
	/*--------------------------------------------------------
	 * DisplayManager constructor
	 * -------------------------------------------------------*/
	public DisplayManager(Display display, Displayable mainDisplayable) {
		
		this.display = display; // only one display object per midlet, this is it
		this.mainDisplayable = mainDisplayable;
		
		// create an alert display when an error occurs
		alStackError = new Alert("Displayable Stack Error");
		alStackError.setTimeout (Alert.FOREVER);
		
	}
	
	
	/*--------------------------------------------------------
	 * Push the curren displayable onto stack and set
	 * the passed in displayable as active
	 * -------------------------------------------------------*/
	public void pushDisplayable(Displayable newDisplayable) {
	
		push(display.getCurrent());
		display.setCurrent(newDisplayable);
		
		
	}
	
	/*--------------------------------------------------------
	 * Return to the main displayable object of MIDlet
	 * -------------------------------------------------------*/
	public void home() {
		
		while (elementCount > 1) {
			pop();
		}
		
		display.setCurrent(mainDisplayable);
	}
	
	/*--------------------------------------------------------
	 * Pop displayable from stack and set as active
	 * -------------------------------------------------------*/
	public void popDisplayable() {
		
		if (empty() == false) {
			display.setCurrent((Displayable) pop());
		} else {
			display.setCurrent(alStackError, mainDisplayable);
		}
		
				
	}
		
		
}
