package com.karensrecipes.midlets;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class MainForm extends List implements CommandListener {
	
	private RecipeBrowser midlet; // reference to the main MIDlet
	private String options[] = new String[3]; // options for this List
	private Command cmView; // next button
	
	public MainForm(RecipeBrowser midlet) {
		
		// call the constructor of the List
		super("Recipe Viewer", List.IMPLICIT);
		
		// save the top level midlet locally
		this.midlet = midlet;
		
		options[0] = "Search";
		options[1] = "Browse";
		options[2] = "About";
		
		// add each category to the List
		for (int i=0; i<options.length; i++) {
	   		append(options[i], null);
		}
		
		
		setCommandListener(this);
		
	}
	
	
	
	
	
	public void commandAction(Command c, Displayable s) {
		
		// we've made a decision
		if (c == List.SELECT_COMMAND) {
			
			// user wants to search
			if (getSelectedIndex() == 0) {
				midlet.displayManager.pushDisplayable(new SearchForm(midlet));
			
			// user wants to browse	
			} else if (getSelectedIndex() == 1) {
				midlet.displayManager.pushDisplayable(new CategoryList(midlet));
			
			// user wants to view about KRS	
			} else {
				midlet.displayManager.pushDisplayable(new AboutForm(midlet));	
			}
				
		
		}			
	}

}
